# coding: utf-8

"""
    TON Rocket Pay API

    This API based on @tonRocketBot (@ton_rocket_test_bot for testnest) Payment System. In order to use it, you need to get API key from bot. Open it and go to Rocket Pay > Create App > API token.<br><br>This page is fully interactive. Provide obtained API key to AUTHORIZE button on the right, and you can try all API methods by simply clicking buttons and filling forms here<br><br>API token must be specified in header of each request. Header name is <b>Rocket-Pay-Key</b>. Only exception is /version endpoint<br><br>If endpoint can send webhooks in response, it is provided on endpoint page on Callbacks bookmark. Now only /tg-invoices endpoint sends webhooks. You can turn them on in bot in app management page<br>In order to verify webhooks information integrity, we send you in headers parameter <b>rocket-pay-signature</b>, which is hex representation of HMAC-SHA-256 signature used to sign request body with a secret key that is SHA256 hash of your app token.<br><br>This specification fully complies with OpenAPI 3.0 standard, so if you want to see schemas of request bodies or responses, please click \"Schema\" inside endpoint. All mandatory fields marked with *, all types and limits also described inside schemas<br><br><h2>Change Log</h2><h3>version 1.3</h3>Added support for multi-invoices:<br>post /tg-invoices - added request parameter numPayments (default - 1), added response parameter totalActivations, activationsLeft<br>webhook /tg-invoices - added parameter payment (telegram user ID and number of items purchased for this payment)<br>get /tg-invoices - added response parameter totalActivations, activationsLeft<br>get /tg-invoices/{id} - added response parameter numPayments and payments (list, info about payments that were maid for this invoice)<br>  # noqa: E501

    OpenAPI spec version: 1.3
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreateTransferDto(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'tg_user_id': 'float',
        'currency': 'str',
        'amount': 'float',
        'transfer_id': 'str',
        'description': 'str'
    }

    attribute_map = {
        'tg_user_id': 'tgUserId',
        'currency': 'currency',
        'amount': 'amount',
        'transfer_id': 'transferId',
        'description': 'description'
    }

    def __init__(self, tg_user_id=None, currency='TONCOIN', amount=None, transfer_id=None, description=None):  # noqa: E501
        """CreateTransferDto - a model defined in Swagger"""  # noqa: E501
        self._tg_user_id = None
        self._currency = None
        self._amount = None
        self._transfer_id = None
        self._description = None
        self.discriminator = None
        self.tg_user_id = tg_user_id
        self.currency = currency
        self.amount = amount
        self.transfer_id = transfer_id
        if description is not None:
            self.description = description

    @property
    def tg_user_id(self):
        """Gets the tg_user_id of this CreateTransferDto.  # noqa: E501

        Telegram user ID. If we dont have this user in DB, we will fail transaction with error: 400 - User not found  # noqa: E501

        :return: The tg_user_id of this CreateTransferDto.  # noqa: E501
        :rtype: float
        """
        return self._tg_user_id

    @tg_user_id.setter
    def tg_user_id(self, tg_user_id):
        """Sets the tg_user_id of this CreateTransferDto.

        Telegram user ID. If we dont have this user in DB, we will fail transaction with error: 400 - User not found  # noqa: E501

        :param tg_user_id: The tg_user_id of this CreateTransferDto.  # noqa: E501
        :type: float
        """
        if tg_user_id is None:
            raise ValueError("Invalid value for `tg_user_id`, must not be `None`")  # noqa: E501

        self._tg_user_id = tg_user_id

    @property
    def currency(self):
        """Gets the currency of this CreateTransferDto.  # noqa: E501

        Currency of transfer, info /currencies/available  # noqa: E501

        :return: The currency of this CreateTransferDto.  # noqa: E501
        :rtype: str
        """
        return self._currency

    @currency.setter
    def currency(self, currency):
        """Sets the currency of this CreateTransferDto.

        Currency of transfer, info /currencies/available  # noqa: E501

        :param currency: The currency of this CreateTransferDto.  # noqa: E501
        :type: str
        """
        if currency is None:
            raise ValueError("Invalid value for `currency`, must not be `None`")  # noqa: E501

        self._currency = currency

    @property
    def amount(self):
        """Gets the amount of this CreateTransferDto.  # noqa: E501

        Transfer amount. 9 decimal places, others cut off  # noqa: E501

        :return: The amount of this CreateTransferDto.  # noqa: E501
        :rtype: float
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this CreateTransferDto.

        Transfer amount. 9 decimal places, others cut off  # noqa: E501

        :param amount: The amount of this CreateTransferDto.  # noqa: E501
        :type: float
        """
        if amount is None:
            raise ValueError("Invalid value for `amount`, must not be `None`")  # noqa: E501

        self._amount = amount

    @property
    def transfer_id(self):
        """Gets the transfer_id of this CreateTransferDto.  # noqa: E501

        Unique transfer ID in your system to prevent double spends  # noqa: E501

        :return: The transfer_id of this CreateTransferDto.  # noqa: E501
        :rtype: str
        """
        return self._transfer_id

    @transfer_id.setter
    def transfer_id(self, transfer_id):
        """Sets the transfer_id of this CreateTransferDto.

        Unique transfer ID in your system to prevent double spends  # noqa: E501

        :param transfer_id: The transfer_id of this CreateTransferDto.  # noqa: E501
        :type: str
        """
        if transfer_id is None:
            raise ValueError("Invalid value for `transfer_id`, must not be `None`")  # noqa: E501

        self._transfer_id = transfer_id

    @property
    def description(self):
        """Gets the description of this CreateTransferDto.  # noqa: E501

        Transfer description  # noqa: E501

        :return: The description of this CreateTransferDto.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CreateTransferDto.

        Transfer description  # noqa: E501

        :param description: The description of this CreateTransferDto.  # noqa: E501
        :type: str
        """

        self._description = description

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateTransferDto, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateTransferDto):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
